import { openBlock as s, createElementBlock as a, createElementVNode as p, resolveComponent as q, resolveDirective as M, createBlock as I, normalizeClass as u, withCtx as k, toDisplayString as w, createCommentVNode as c, normalizeStyle as b, renderSlot as v, withDirectives as S, createVNode as P, vShow as B, Fragment as _, renderList as z } from "vue";
import F from "axios";
import { isString as C, isArray as m, isPlainObject as x, isEqual as T, uniqBy as E, isFunction as y, isBoolean as L } from "lodash-es";
import { at as O, a7 as V, ad as D, aa as N, ac as A, b5 as W, b6 as j, b7 as H } from "./index-759d07fa.js";
import { e as G } from "./externalApi-5368ea99.js";
import "@vueuse/core";
import "vue-i18n";
const K = {
  viewBox: "0 0 24 24",
  width: "1em",
  height: "1em"
}, R = /* @__PURE__ */ p("path", {
  fill: "currentColor",
  d: "m7 10l5 5l5-5H7Z"
}, null, -1), U = [
  R
];
function Y(e, n) {
  return s(), a("svg", K, [...U]);
}
const Z = { name: "mdi-arrow-drop-down", render: Y }, J = `.kapix-select-input-container{cursor:pointer}.kapix-select-input-container.disabled{-webkit-user-select:none;user-select:none;opacity:.8;cursor:default}.kapix-select-input-container.display-only{cursor:default}.kapix-select-input-container.add-button{text-align:center}.kapix-select-input-container.add-button .kapix-select-input-placeholder{color:inherit}.kapix-select-input-container.icon-mode{border:none}.kapix-select-input-container.icon-mode .icon{margin:0!important;width:auto;cursor:pointer}.kapix-select-input-container.icon-mode .label,.kapix-select-input-container.icon-mode .icon-container{display:none}.kapix-select-input-header{display:flex;flex-direction:row;align-items:center;margin-right:5px}.kapix-select-input-content{width:100%;height:100%;min-width:0;min-height:0;display:flex;flex-direction:row;overflow:hidden;position:relative;align-items:center}.kapix-select-input-content .icon-container{overflow:hidden;width:30px;display:flex;align-items:center}.kapix-select-input-content .arrow-icon{transition:.3s cubic-bezier(.25,.8,.5,1);color:inherit;font-size:22px}.kapix-select-input-content.is-active .arrow-icon{transform:rotate(180deg)}.kapix-select-input-content .selected-item{white-space:nowrap;position:relative;overflow:hidden;text-overflow:ellipsis}.kapix-select-input-content .selected-item .v-icon{color:inherit}.kapix-select-input{width:100%;min-width:0}.showing-progress{position:absolute;width:99%;bottom:0}.kapix-select-input-placeholder{white-space:nowrap;position:relative;overflow:hidden;text-overflow:ellipsis;color:#bbb}.kapix-select-input-menu-container{display:flex;flex-direction:column;max-height:450px;border:1px solid rgba(128,128,128,.36);border-radius:5px;background:white;box-shadow:0 3px 3px -2px #0003,0 3px 4px #00000024,0 1px 8px #0000001f}.kapix-select-input-menu{overflow-x:hidden;overflow-y:auto;max-height:40vh;padding:10px 0;text-align:left;min-width:130px}.kapix-select-input-menu::-webkit-scrollbar-thumb{background-color:currentColor;border-radius:9px;border:solid 6px transparent;background-clip:content-box}.kapix-select-input-menu::-webkit-scrollbar-thumb:hover{border-width:5px}.kapix-select-input-menu::-webkit-scrollbar{height:18px;width:18px}@media (max-width: 599.98px){.kapix-select-input-menu::-webkit-scrollbar{height:0;width:0}}.kapix-select-input-menu::-webkit-scrollbar:disabled{display:none}.kapix-select-input-menu::-webkit-scrollbar-button,.kapix-select-input-menu ::-webkit-scrollbar-corner{cursor:pointer;background:transparent}.kapix-select-input-menu::-webkit-scrollbar-button:horizontal:decrement,.kapix-select-input-menu::-webkit-scrollbar-button:horizontal:increment,.kapix-select-input-menu::-webkit-scrollbar-button:vertical:decrement,.kapix-select-input-menu::-webkit-scrollbar-button:vertical:increment{display:none}.kapix-select-input-menu::-webkit-scrollbar-button:vertical:start:increment,.kapix-select-input-menu::-webkit-scrollbar-button:vertical:end:decrement,.kapix-select-input-menu::-webkit-scrollbar-button:horizontal:start:increment,.kapix-select-input-menu::-webkit-scrollbar-button:horizontal:end:decrement{display:none}.kapix-select-input-menu::-webkit-scrollbar-track{background:transparent}.kapix-select-input-menu::-webkit-scrollbar-thumb:vertical{min-height:50px}.kapix-select-input-menu::-webkit-scrollbar-thumb:horizontal{min-width:50px}.kapix-select-input-menu.no-padding-top{padding-top:0}.kapix-select-input-menu .separator{display:flex;flex-direction:row;align-items:center;justify-content:center;padding:5px;margin-bottom:5px;border-bottom:1px solid lightgrey}.kapix-select-input-menu .separator:last-child,.kapix-select-input-menu .separator:first-child{display:none}.kapix-select-input-menu .separator.header{display:flex;flex-direction:row;text-align:center;margin-top:5px}.kapix-select-input-menu .separator.header:last-child{display:none}.kapix-select-input-menu .separator.header:first-child{margin:0}.kapix-select-input-menu .separator+.separator{display:none}.default-item-template{white-space:nowrap;position:relative;overflow:hidden;text-overflow:ellipsis;display:flex;flex-direction:row;justify-content:space-between;width:100%;align-items:center}.default-item-template .icon{margin-right:5px;width:30px}.default-item-template .label{text-align:left;width:100%}.default-item-template .subtitle{white-space:break-spaces;margin-top:5px;margin-bottom:5px;font-size:11px;opacity:.7}.default-item-template.subtitle{padding:5px 0}.kapix-select-input-item{min-height:35px;display:flex;z-index:5;align-items:center;padding:0 10px;cursor:pointer}.kapix-select-input-item.selected{color:#3899ec;background-color:#d3d3d333;border-right:2px solid}.kapix-select-input-item.disabled{background-color:#d3d3d34d;opacity:.5;cursor:no-drop}.kapix-select-input-item:hover{background-color:#d3d3d34d}.kapix-select-input-item .v-icon{color:inherit}
`;
V("KapixDropDown", J);
const Q = {
  name: "KapixDropDown",
  inject: {
    $entityContext: { default: null }
  },
  props: {
    modelValue: {
      type: [String, Number, Boolean, Object, Array, null],
      default: null
    },
    disabled: {
      type: Boolean,
      default: !1,
      required: !1
    },
    noSelectionStyle: {
      type: Boolean,
      default: !1,
      required: !1
    },
    zIndex: {
      type: Number,
      default: void 0,
      required: !1
    },
    itemGroupIsElement: {
      type: [Boolean, String, Function],
      default: null,
      required: !1
    },
    itemPrependIcon: {
      type: [String, Function],
      default: null,
      required: !1
    },
    itemIcon: {
      type: [String, Function],
      default: "icon",
      required: !1
    },
    itemColor: {
      type: [String, Function],
      default: "color",
      required: !1
    },
    itemIconClass: {
      type: [String, Function],
      default: "iconClass",
      required: !1
    },
    itemSubtitle: {
      type: [String, Function],
      default: "description",
      required: !1
    },
    itemClass: {
      type: [String, Array, Function],
      default: "className",
      required: !1
    },
    itemText: {
      type: [String, Array, Function],
      default: "label",
      required: !1
    },
    itemValue: {
      type: [String, Function],
      default: "value",
      required: !1
    },
    itemStyle: {
      type: [String, Function],
      default: null,
      required: !1
    },
    itemDisabled: {
      type: [String, Function],
      default: null,
      required: !1
    },
    itemTooltip: {
      type: [String, Function],
      default: null,
      required: !1
    },
    placeholder: {
      type: String,
      default: "Select a value...",
      required: !1
    },
    items: {
      type: Array,
      default: null,
      required: !1
    },
    clearable: {
      type: Boolean,
      default: !1,
      required: !1
    },
    async: {
      type: Boolean,
      default: !1,
      required: !1
    },
    returnObject: {
      type: Boolean,
      default: !1,
      required: !1
    },
    itemCompare: {
      type: [String, Function],
      default: null,
      required: !1
    },
    search: {
      type: String,
      default: null,
      required: !1
    },
    recursive: {
      type: [Boolean, Function],
      default: !0,
      required: !1
    },
    showArrow: {
      type: Boolean,
      default: !0,
      required: !1
    },
    showSearch: {
      type: Boolean,
      default: !0,
      required: !1
    },
    addButton: {
      type: Boolean,
      default: !1,
      required: !1
    },
    icon: {
      type: Boolean,
      default: !1,
      required: !1
    },
    boundsLimit: {
      type: Boolean,
      default: !1,
      required: !1
    },
    stopEventOnClick: {
      type: Boolean,
      default: !0,
      required: !1
    },
    menuArrow: {
      type: Boolean,
      default: !1,
      required: !1
    },
    menuDistance: {
      type: Number,
      default: 2,
      required: !1
    },
    menuPlacement: {
      type: String,
      default: "bottom-start",
      required: !1
    },
    menuAnimation: {
      type: [String, Boolean],
      required: !1,
      default: "shift-away",
      validator: (e) => C(e) ? ["shift-away", "shift-toward", "fade", "scale", "perspective"].includes(e) : !0
    },
    menuPlacementUpdate: {
      type: Boolean,
      default: !1,
      required: !1
    },
    inputCy: {
      type: String,
      default: void 0
    },
    displayOnly: {
      type: Boolean,
      default: void 0
    },
    dataSource: {
      type: Object,
      default: void 0
    }
  },
  emits: ["update:modelValue", "update:search", "change", "show", "hidden", "item-mouse-enter", "item-mouse-leave"],
  data() {
    return {
      showMenu: !1,
      showingMenu: !1,
      internalSearch: null,
      maxWidth: null,
      dataSourceItems: null,
      isFetching: !1,
      indexWrapper: {
        index: {}
      }
    };
  },
  computed: {
    dropdownStyle({ maxWidth: e }) {
      return e && {
        minWidth: `${e}px`
      };
    },
    isEmpty() {
      return this.selectedItem == null;
    },
    formattedDataSourceItems({ dataSourceItems: e, dataSource: n }) {
      return m(e) ? e.map((t) => {
        if (n && x(t)) {
          const o = t[n.itemText], r = t[n.itemValue];
          return {
            label: o,
            value: r
          };
        }
      }) : D;
    },
    internalItems({ items: e }) {
      return m(e) ? e : D;
    },
    normalizedValue({ returnObject: e, modelValue: n }) {
      return e && x(n) ? this.getValue(n) : n;
    },
    selectedItem({ normalizedItems: e, normalizedValue: n }) {
      var o;
      const t = this.findNormalizedItem(e, n);
      return !t && ((o = this.$entityContext) != null && o.showSkeleton) ? {
        label: "•••"
      } : t && {
        ...t,
        label: t.displayPath
      };
    },
    computedSearch: {
      get() {
        return this.search || this.internalSearch;
      },
      set(e) {
        this.internalSearch = e, this.$emit("update:search", e);
      }
    },
    normalizedSearch({ computedSearch: e }) {
      return e && e.toLowerCase();
    },
    normalizedItems() {
      return this.normalizeItems([
        ...this.internalItems,
        ...this.formattedDataSourceItems
      ]);
    },
    filteredItems({ normalizedItems: e, normalizedSearch: n }) {
      return e && (n ? e.filter((t) => t.normalizedLabel ? t.normalizedLabel.includes(n) : !1) : e);
    },
    maxWidthStyle() {
      return this.boundsLimit && this.maxWidth ? `${this.maxWidth}px` : "500px";
    },
    computedDisabled() {
      return this.disabled || this.displayOnly;
    }
  },
  watch: {
    showMenu(e) {
      e ? (this.$nextTick(this.onShowMenuOpened), this.$emit("show", !0)) : this.$emit("hidden", !0);
    },
    "dataSource.getAll": {
      immediate: !0,
      async handler(e, n) {
        if (this.isFetching || T(e, n))
          return;
        let t = !1;
        if (e)
          try {
            this.isFetching = !0;
            const { url: o } = e, r = G(e), i = o && await N(o, () => F.get(o, r));
            if (i && i.data) {
              let d;
              m(i.data) ? d = i.data : x(i.data) && forOwn(i.data, (h, f) => {
                m(h) && (d = i.data);
              }), m(d) && (t = !0, this.dataSourceItems = d);
            }
          } catch (o) {
            console.error(o);
          } finally {
            this.isFetching = !1;
          }
        t || (this.dataSourceItems = null);
      }
    }
  },
  methods: {
    isSeparator: A,
    findNormalizedItem(e, n, t = 0) {
      if (e) {
        const { itemCompare: o } = this;
        let r = e.find((i) => W(i.value, n, o));
        return !r && n !== void 0 && e.forEach((i) => {
          !r && (i._children || t === 0 && i.children) && (r = this.findNormalizedItem(i.children(), n, t + 1));
        }), r;
      }
    },
    isSubSelected(e) {
      return e && e.value === this.normalizedValue;
    },
    normalizeItems(e, n) {
      return m(e) && E(e.map((t, o) => {
        if (t) {
          if (this.isSeparator(t)) {
            if (this.isSeparator(e[o - 1]))
              return null;
            const f = `separator-${o}`;
            return {
              ...t,
              separator: !0,
              value: f,
              index: f
            };
          }
          C(t) && (t = {
            label: t,
            value: t
          });
          const r = this.getLabel(t), i = n ? `${n} > ${r}` : r;
          let d, h;
          return t.children && (y(this.recursive) ? this.recursive(t) : this.recursive) && (y(t.children) ? d = () => this.normalizeItems(t.children(), i) : (h = this.normalizeItems(t.children, i), d = () => h)), {
            ...t,
            label: r,
            displayPath: i,
            value: this.getValue(t),
            normalizedLabel: r && r.toString().toLowerCase(),
            isElement: d && this.getGroupIsElement(t),
            prependIcon: this.getPrependIcon(t),
            icon: this.getIcon(t),
            iconClass: this.getIconClass(t),
            className: this.getClass(t),
            subtitle: this.getSubtitle(t),
            disabled: this.getDisabled(t),
            tooltip: this.getTooltip(t),
            style: {
              color: this.getColor(t),
              ...this.getStyle(t)
            },
            _children: h,
            children: d,
            item: t,
            index: o,
            get self() {
              return this;
            }
          };
        }
      }).filter((t) => t != null), "value");
    },
    updateValue(e) {
      this.computedDisabled || (this.$emit("update:modelValue", e), this.$emit("change", e));
    },
    clickItem(e) {
      e && e.disabled || (e && !this.returnObject ? this.updateValue(e.value) : this.updateValue(e && e.item), this.showMenu = !1);
    },
    clickSubItem({ item: e }) {
      this.clickItem(e);
    },
    getLabel(e) {
      if (this.itemText)
        if (m(this.itemText)) {
          let n;
          return this.itemText.forEach((t) => {
            n == null && (n = this.getDescendantProp(e, t));
          }), n;
        } else
          return this.getDescendantProp(e, this.itemText);
      return e;
    },
    getValue(e) {
      return this.itemValue && !this.returnObject ? this.getDescendantProp(e, this.itemValue) : e;
    },
    getGroupIsElement(e) {
      return this.getDescendantProp(e, this.itemGroupIsElement);
    },
    getPrependIcon(e) {
      return this.getDescendantProp(e, this.itemPrependIcon);
    },
    getColor(e) {
      return this.getDescendantProp(e, this.itemColor);
    },
    getIcon(e) {
      return this.getDescendantProp(e, this.itemIcon);
    },
    getIconClass(e) {
      return this.getDescendantProp(e, this.itemIconClass);
    },
    getClass(e) {
      return this.getDescendantProp(e, this.itemClass);
    },
    getStyle(e) {
      return this.getDescendantProp(e, this.itemStyle);
    },
    getDisabled(e) {
      return this.getDescendantProp(e, this.itemDisabled);
    },
    getTooltip(e) {
      const n = this.getDescendantProp(e, this.itemTooltip);
      return n && (x(n) ? n : { content: n, placement: "left" });
    },
    getSubtitle(e) {
      return this.getDescendantProp(e, this.itemSubtitle);
    },
    getDescendantProp(e, n) {
      return n ? L(n) ? n : y(n) ? n(e) : j(e, n) : null;
    },
    openMenu(e) {
      !this.computedDisabled && this.items && this.items.length && (this.stopEventOnClick && e && e.stopPropagation(), this.maxWidth = this.$el.offsetWidth, this.async ? this.showMenu ? this.showMenu = !1 : (this.showingMenu = !0, setTimeout(() => {
        this.showingMenu = !1, this.showMenu = !0;
      }, 500)) : this.showMenu = !this.showMenu);
    },
    onShowMenuOpened() {
      const e = this.$refs.scrollerMenu;
      e && this.showMenu && this.selectedItem && H({
        el: `item-${this.selectedItem.index}`,
        duration: 0,
        offset: -40,
        container: e
      });
    },
    onItemMouseEnter(e) {
      this.indexWrapper.index = {}, this.$emit("item-mouse-enter", e);
    },
    onItemMouseLeave(e) {
      this.$emit("item-mouse-leave", e);
    }
  }
}, X = { class: "kapix-select-input" }, $ = {
  key: 0,
  class: "kapix-select-input-placeholder"
}, ee = { class: "default-item-template" }, te = ["innerHTML"], ie = { class: "icon-container" }, ne = { key: 1 }, le = ["data-cy", "onClick", "onMouseenter", "onMouseleave"], re = {
  key: 1,
  class: "text-no-wrap label"
}, se = ["innerHTML"], ae = ["innerHTML"];
function oe(e, n, t, o, r, i) {
  const d = Z, h = q("tippy"), f = M("tippy");
  return s(), I(h, {
    class: u(["kapix-select-input-container", {
      disabled: t.disabled,
      "display-only": t.displayOnly,
      "add-button": t.addButton,
      "icon-mode": t.icon
    }]),
    visible: r.showMenu,
    "update-on-change": t.menuPlacementUpdate,
    interactive: "",
    "z-index": t.zIndex,
    distance: t.menuDistance,
    "max-width": i.maxWidthStyle,
    placement: t.menuPlacement,
    animation: t.menuAnimation,
    arrow: t.menuArrow,
    theme: "no",
    trigger: "manual",
    "data-cy": t.inputCy,
    onHidden: n[1] || (n[1] = (l) => r.showMenu = !1),
    onClick: n[2] || (n[2] = (l) => i.openMenu(l))
  }, {
    trigger: k(() => [
      p("div", {
        class: u(["kapix-select-input-content", r.showMenu && "is-active"])
      }, [
        p("div", X, [
          i.isEmpty ? (s(), a("div", $, w(t.placeholder), 1)) : c("", !0),
          i.selectedItem ? (s(), a("div", {
            key: 1,
            class: u(["selected-item", i.selectedItem.className]),
            style: b(t.noSelectionStyle ? void 0 : i.selectedItem.style)
          }, [
            v(e.$slots, "selection", {
              item: i.selectedItem.item,
              formattedItem: i.selectedItem
            }, () => [
              p("div", ee, [
                i.selectedItem.prependIcon ? (s(), a("div", {
                  key: 0,
                  class: u([i.selectedItem.prependIcon, "mr-2"])
                }, null, 2)) : c("", !0),
                p("div", {
                  class: "text-no-wrap label",
                  innerHTML: i.selectedItem.label
                }, null, 8, te),
                i.selectedItem.icon ? (s(), a("div", {
                  key: 1,
                  class: u([i.selectedItem.icon, "ml-2"])
                }, null, 2)) : c("", !0)
              ])
            ])
          ], 6)) : c("", !0)
        ]),
        S(p("div", ie, [
          P(d, { class: "arrow-icon" })
        ], 512), [
          [B, t.showArrow && !i.computedDisabled]
        ])
      ], 2)
    ]),
    default: k(() => [
      r.showMenu && !i.computedDisabled && t.items ? (s(), a("div", {
        key: 0,
        style: b(i.dropdownStyle),
        class: "kapix-select-input-menu-container"
      }, [
        p("div", {
          ref: "scrollerMenu",
          class: u(["kapix-select-input-menu", { "no-padding-top": i.filteredItems[0] && i.filteredItems[0].separator }])
        }, [
          t.clearable && !i.isEmpty ? (s(), a("div", {
            key: 0,
            class: "kapix-select-input-item",
            onClick: n[0] || (n[0] = (l) => i.clickItem(null))
          })) : c("", !0),
          (s(!0), a(_, null, z(i.filteredItems, (l) => (s(), a(_, null, [
            l.separator ? (s(), a("div", {
              key: `separator-${l.index}`,
              class: u(["separator", l.header && ["header", l.className || e.mainColor]])
            }, [
              l.prependIcon ? (s(), a("div", {
                key: 0,
                class: u([l.prependIcon, "mr-2"])
              }, null, 2)) : c("", !0),
              l.header ? (s(), a("span", ne, w(l.header), 1)) : c("", !0),
              l.icon ? (s(), a("div", {
                key: 2,
                class: u([l.icon, "ml-2"])
              }, null, 2)) : c("", !0)
            ], 2)) : S((s(), a("div", {
              key: l.index,
              "data-cy": t.inputCy && `${t.inputCy}-item-${l.index}`,
              class: u(["kapix-select-input-item", [
                `item-${l.index}`,
                l.className,
                i.selectedItem && l.item === i.selectedItem.item && "selected",
                l.disabled && "disabled"
              ]]),
              style: b(l.style),
              onClick: (g) => i.clickItem(l),
              onMouseenter: (g) => i.onItemMouseEnter(l),
              onMouseleave: (g) => i.onItemMouseLeave(l)
            }, [
              v(e.$slots, "item", {
                selected: i.selectedItem && l.item === i.selectedItem.item,
                formattedItem: l,
                item: l.item,
                index: l.index
              }, () => [
                p("div", {
                  class: u(["default-item-template", l.subtitle && "subtitle"])
                }, [
                  l.prependIcon ? (s(), a("div", {
                    key: 0,
                    class: u([l.prependIcon, "mr-2"])
                  }, null, 2)) : c("", !0),
                  l.label ? (s(), a("div", re, [
                    p("div", {
                      innerHTML: l.label
                    }, null, 8, se),
                    l.subtitle ? (s(), a("div", {
                      key: 0,
                      class: "subtitle",
                      innerHTML: l.subtitle
                    }, null, 8, ae)) : c("", !0)
                  ])) : c("", !0),
                  l.icon ? (s(), a("div", {
                    key: 2,
                    class: u([l.icon, "ml-2"])
                  }, null, 2)) : c("", !0)
                ], 2)
              ])
            ], 46, le)), [
              [f, l.tooltip]
            ])
          ], 64))), 256))
        ], 2)
      ], 4)) : c("", !0)
    ]),
    _: 3
  }, 8, ["class", "visible", "update-on-change", "z-index", "distance", "max-width", "placement", "animation", "arrow", "data-cy"]);
}
const xe = /* @__PURE__ */ O(Q, [["render", oe]]);
export {
  xe as default
};
